<script setup lang="ts">
import { ref } from 'vue'

import { useAuthStore } from '@/stores/auth'
import { useCheckInStore } from '@/stores/checkIn'
const checkInStore = useCheckInStore()
// const currentDate = ref()
const currentTime = ref()

const username = ref('')
const password = ref('')
const authStore = useAuthStore()
const tableData = ref([])
const show = ref(false)
const confirmCheckOutDialogVisible = ref(false)

const currentDate = ref(new Date().toLocaleDateString());
const alreadyCheckedIn = ref(false);


function showCheckInDialog() {
  
  const userCheckedInToday = checkInStore.checkInOuts.some(entry => {
    return entry.user.id === authStore.currentUser!.id && entry.date === currentDate.value;
  });

  if (!userCheckedInToday && !alreadyCheckedIn.value) {
    checkInStore.dialogVisible = true;
  } else {
    if (userCheckedInToday) {
      checkInStore.checkoneday = !checkInStore.checkoneday
      console.log("คุณได้ทำการ Check In วันนี้แล้ว");
    } 
    }
  }


// function showCheckInDialog() {
  
//   if (!alreadyCheckedIn.value) {
//     dialogVisible.value = true;
//   } else {
//     checkoneday.value = !checkoneday.value
//     console.log("คุณได้ทำการ Check In วันนี้แล้ว");
    
    
//   }
// }


function onConfirmButtonClick() {
  // ตรวจสอบว่าผู้ใช้ได้ Check In วันนี้แล้วหรือไม่
  const userCheckedInToday = checkInStore.checkInOuts.some(entry => {
    return entry.user.id === authStore.currentUser!.id && entry.date === currentDate.value;
  });

  if (!userCheckedInToday && !alreadyCheckedIn.value) {
    checkInStore.chkUser();
    confirmCheckIn();
    checkInStore.checkInTime();
    alreadyCheckedIn.value = true;
  }
}

// function onConfirmButtonClick() {
//   if (!alreadyCheckedIn.value) {
    
//     checkInStore.chkUser();
//     confirmCheckIn();
//     checkInStore.checkInTime();
    
    
//     alreadyCheckedIn.value = true;
//   }
// }

function confirmCheckIn() {
  checkInStore.showCheckInButton = false
  checkInStore.dialogVisible = false
}

function confirmCheckOut() {
  checkInStore.showCheckInButton = true
  confirmCheckOutDialogVisible.value = true
  checkInStore.checkOutTime()
}

// function showCheckInDialog() {
//   dialogVisible.value = true
// }

function CancelCheckInDialog() {
  checkInStore.dialogVisible = false
}

// function onConfirmButtonClick() {
//   checkInStore.chkUser() // Call the login method
//   confirmCheckIn() // Call the confirmCheckIn method
//   checkInStore.checkInTime()

//   // console.log(checkImOutStore.handleCheckIn)
// }

function dateTime() {
  const now = new Date()
  currentDate.value = now.toLocaleDateString()
  currentTime.value = now.toLocaleTimeString()
}
setInterval(dateTime, 1000) // Set interval to 1000ms (1 second)

const required = (v: any) => {
  return !!v || 'Field is required'
}
</script>

<template>
  <v-container>
    <v-row class="ma-2">
      <v-col>
        <p style="font-size: 50px; text-align: center; font-weight: bold; color: white;">{{ currentTime }}</p>
      </v-col>
    </v-row>

    <v-row>
      <v-col v-if="checkInStore.showCheckInButton">
        <v-btn block rounded="xl" size="50" color="green" @click="showCheckInDialog"
          >CHECK IN</v-btn
        >
      </v-col>
      <v-col v-if="!checkInStore.showCheckInButton">
        <v-btn block rounded="xl" size="50" color="red" @click="confirmCheckOut">CHECK OUT</v-btn>
      </v-col>
    </v-row>
    <v-dialog v-model="checkInStore.dialogVisible" max-width="400">
      <v-card class="pa-3" style="text-align: center">
        <v-card-title>CHECK IN</v-card-title>
        <v-card-text class="justify-center align-center pa-18">
          <v-form>
            <v-text-field
              v-model="authStore.email"
              :rules="[required]"
              class="mb-2"
              clearable
              label="Email"
              placeholder="Enter your Email"
            ></v-text-field>
            <v-text-field
              v-model="authStore.password"
              :rules="[required]"
              clearable
              label="Password"
              placeholder="Enter your Password"
              :type="show ? 'text' : 'password'"
            >
              <template v-slot:append-inner>
                <v-icon :icon="show ? 'mdi-eye' : 'mdi-eye-off'" @click="show = !show"></v-icon>
              </template>
            </v-text-field>

            <v-row>
              <v-col>
                <v-btn color="red" @click="CancelCheckInDialog">Cancel</v-btn>
              </v-col>
              <v-col>
                <v-btn color="green" @click="onConfirmButtonClick">Confirm</v-btn>
              </v-col>
            </v-row>
          </v-form>
        </v-card-text>
      </v-card>
    </v-dialog>

    <v-dialog v-model="checkInStore.checkoneday" width="550">
      <template v-slot:default="{ isActive }">
        <v-card title="Warning">
          <v-card-text> Unable to check in because you have already checked in today. </v-card-text>

          <v-card-actions>
            <v-spacer></v-spacer>

            <v-btn text="Close" color="red" @click="isActive.value = false"></v-btn>
          </v-card-actions>
        </v-card>
      </template>
    </v-dialog>

  </v-container>
  <v-table class="ma-2 rounded-xl">
    <thead>
      <tr>
        <th class="text-center">DATE</th>
        <th class="text-center">NAME</th>
        <th class="text-center">TIME IN</th>
        <th class="text-center">TIME OUT</th>
        <th class="text-center">TOTAL HOUR</th>
        <th class="text-center">Total</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="(entry, index) in checkInStore.checkInOuts" :key="index">
        <td class="text-center" v-if="(entry.user.id = authStore.currentUser!.id)">
          {{ entry.date }}
        </td>
        <td class="text-center" v-if="(entry.user.id = authStore.currentUser!.id)">
          {{ entry.user.fullname }}
        </td>
        <td class="text-center" v-if="(entry.user.id = authStore.currentUser!.id)">
          {{ entry.in }}
        </td>
        <td class="text-center" v-if="(entry.user.id = authStore.currentUser!.id)">
          {{ entry.out }}
        </td>
        <td class="text-center" v-if="(entry.user.id = authStore.currentUser!.id)">
          {{ entry.hour }}
        </td>
        <td class="text-center" v-if="(entry.user.id = authStore.currentUser!.id)">
          {{ entry.total }}
        </td>
      </tr>
    </tbody>
  </v-table>
</template>

<style scoped>
tbody tr:nth-of-type(even) {
  background-color: white;
}

tbody tr:nth-of-type(odd) {
  background-color: white;
}

thead {
  background-color: white;
  color: rgb(0, 0, 0);
  font-weight: bold;
}


.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
